var APP = APP || {};
APP.navData = {
	moduleId: 0,
	topicId: 0,
	screenId: 0,
	currentScreenObj:{},
	currentScreenTemplate:{}
}

APP.userQuizData = []; 

APP.globalQuizObj = {
	currentQuizId:0,
	totalAvlQuiz:1,
	isAvalable:false,
}
//
APP.iconObj = {
	locked: 'icon-lock',
	notAttempted: 'icon-menu-not-attempt',
	incomplete: 'icon-menu-incomplete',
	complete: 'icon-menu-complete',
	optional: 'icon-circle-plus',
}
APP.courseBookmark="";

APP.userLanguageChanged = false;
APP.globalMessageOpen = false;

APP.beforeUnloadFired = false;
APP.courseClosed=false;
APP.winWillClose=false;
APP.isSideNavMenuOpen = false;
APP.currentTime;
APP.CertificateOpt = 0;
APP.coursePassDate = '';

APP.winOpener = top.opener;

//--custom for course
APP.isMenuShowFirstTime = true;
APP.userTopicSelectionObj={
	profilerOne:'',
	profilerTwo:'',
	
}

APP.inlineQuizObj = {
	totQues: 0,
	queArr: [],
	score: 0,
	revMod: 'off',
	revArr: '',
	revInx: 0,
}
//--
APP.prevView = "";
APP.gbBgImgPath = "";
APP.gbBgIndex = 0;
APP.isFirstTimeLoad = true;

var globalImgs = [	
	"framework/images/st_logo.svg",	
	"framework/images/logo_white.png",	
	"framework/images/ltr/plyr/plyr_sprite.svg",	
	
]

APP.vidPlayer = null;
APP.screenAudio = null;
APP.soundEffectAudio = null;
APP.soundBgAudio = null;
APP.soundBgAudio1 = null;
APP.isScreenAudioPlay = true;
APP.scalex = 1;
var winWd = window.screen.availWidth;
var winHt = window.screen.availHeight;
window.moveTo(0, 0);
window.resizeTo(winWd, winHt);

$(document).ready(function () {
	/* $(document).bind("contextmenu", function (e) {
		e.preventDefault();
	}); */
	APP.configObj = new Configuration();
	APP.systemDetectorObj = new SystemDetector();	
	APP.systemDetectorObj.init();	
	if(document.body._gsTransform){
		APP.scalex = document.body._gsTransform.scaleX;
	}
	if(APP.configObj.system.toBeChecked){
		var sys = new SystemValidator();
		sys.start();	
	}else{
		loadFramework();
	}
});

function loadFramework(){	
	$('body').html(getFrameworkHtml());
		
	APP.preloaderObj = new Preloader();
	APP.preloaderObj.show();
	APP.animationObj = new AppAnimation();
	APP.commonFunObj = new Common();
	APP.getHtmlStructObj = new GetHtmlStructure();
	
	//APP.commonFunObj.preloadImages(globalImgs);
	APP.prevView = APP.commonFunObj.getCurrentView();
		
	APP.loadFilesObj = new LoadFiles();
	APP.globalXmlsObj = new GlobalXmlData();
	APP.navigationObj = new Navigation();
	APP.eventObj = new AppEvent();
	APP.courseDataObj = new CourseData();
	APP.dataComObj = new DataCompliance();	
	APP.progressBarObj = new ProgressBar();
	
	APP.courseDataObj.initGlobalQuizObj();

	APP.commonFunObj.scaleContents();
	APP.progressBarObj.createHtml();
	var currentView = APP.commonFunObj.getCurrentView();
	if(currentView == 'mobile'){
		APP.scalex = 1;
	}
	//--for draggable
	Draggable.create($( "#debug-screener" ), {
		type:"x,y",
		bounds: window,
		cursor:"move",
		zIndexBoost: true,
	});

	loadXmls();
}
function loadXmls(){
	APP.currentTime = new Date();
	APP.globalXmlsObj.loadNavigationXML();
}
function startCourse(){
//-- check value
	APP.prevLanguageObj = {
		lang:(APP.configObj.language.lang==null || APP.configObj.language.lang=='') ? APP.configObj.language.defaultLang : APP.configObj.language.lang,
		dir:(APP.configObj.language.dir==null || APP.configObj.language.dir=='') ? APP.configObj.language.defaultDir : APP.configObj.language.dir
	}
	APP.courseDataObj.validatePrevData();	
	APP.eventObj.applyBgVideoEvent();
}

function getFrameworkHtml() {
	var str = "";
	
	/* 1 */str += '<div id="app-body" class="app-body centered">'
	str += '<div id="sidenav_menu" class="sidenav_menu"></div>';
	str += '<div id="main-div" class="main-div">';
	str += '<div class="preloader-parent" ></div>';
	str += '<div id="alpha-bg" class="alpha-bg"></div>';	
	//-- have video playing issue in ios 16
	/* str += '<div id="play-overlay" class="play-overlay hide">';
		str += '<a href="javascript:void(0);" class="btn transBg play-overlay-btn"><span class="btn-icon font-icon icon-play display-cell v-center center"></span></a>';
	str += '</div>'; */
	str += '<div id="global-modal-pop" class="global-modal-pop"></div>';
	
	/*str += '<div id="global-bg" class="background"></div>';*/
	str += '<div id="global-bg-0" class="background gb-bck-0"></div>';
	str += '<div id="global-bg-1" class="background gb-bck-1"></div>';
	str += '<video id="bg-video" class="bg-video hide" crossorigin="anonymous" width="100%" style="max-width: 100%" disablePictureInPicture playsinline webkit-playsinline muted loop preload="metadata" controlsList="nodownload" >';
		str += '<source id="mp4_src" src="" type="video/mp4">';
	str += '</video>';
	/* 2 */str += '<div class="header hide">';
			str += '<div class="navigation-panel">';
				str += '<div class="display-table ">';
				str += '<div class="logo-cell mobile display-cell v-center" >';
					str += '<img class="logo  " src="framework/images/st_logo.svg" alt="" >';
				str += '</div>';
				str += '<div class="btn-panel desktop back-to-menu-btn-panel display-cell v-center" >';
					str += '<a id="back-to-menu-btn" class="btn back-to-menu-btn">';
						str += '<span class="btn-icon font-icon icon-back_to_menu v-center center display-cell " ></span>';
						str += '<span class="btn-txt v-center left display-cell"></span>';
					
					str += '</a>';
				str += '</div>';
				str += '<div class="gap-cell display-cell v-center" ></div>';
					/* str += '<div class="btn-panel audio-btn-panel display-cell v-center" >';
						str += '<a id="audio-btn" class="btn audio-btn on">';
							str += '<div class="display-row btn-icon-row">';
								str += '<span class="font-icon btn-icon icon-audio-on v-center center display-cell"></span>';
							str += '</div>';
						str += '</a>';
					str += '</div>'; */
					str += '<div class="btn-panel menu-btn-panel display-cell v-center" >';
						str += '<a id="menu-btn" class="btn menu-btn ">';
							str+='<div class="display-row btn-icon-row">';
								str+='<span class="font-icon btn-icon icon-burger-menu v-center center display-cell"></span>'; 
							str+='</div>';
						str += '</a>';
					str += '</div>';
				str += '</div>';
			str += '</div>';		
	/* 2 */str += '</div>';
	str += '<div id="side-navigation" class="side-navigation hide">';
		str += '<div class="btn-panel back">';
			str += '<a class="btn btn-back icon-only" href="javascript:void(0);" ><span class="btn-icon font-icon icon-back display-cell v-center"></span></a>';				
		str += '</div>';
		str += '<div class="btn-panel next">';
			str += '<a class="btn btn-next icon-only" href="javascript:void(0);" ><span class="btn-icon font-icon icon-next display-cell v-center"></span></a>';				
		str += '</div>';
	str += '</div>';
	str += '<div id="content-master" class="content-master">';
		str += '<div id="screen-container" class="screen-container">';
		str += '</div>';
	str += '</div>';	
	str += '<div id="bottom-navigation" class="bottom-navigation " >';
		str += '<div class="btn-panel back">';
			str += '<a class="btn btn-back display-table" href="javascript:void(0);" ><span class="btn-icon font-icon icon-back display-cell v-center"></span></a>';
		str += '</div>';
		str += '<div class="gap-div"></div>';
		str += '<div class="btn-panel next">';
			str += '<a class="btn btn-next display-table" href="javascript:void(0);" ><span class="btn-icon font-icon icon-next display-cell v-center"></span></a>';
		str += '</div>';
	str += '</div>';		
	str += '<div id="footer" class="footer desktop">';
		str += '<div class="bottom-logo ">';
			str += '<img class="logo  " src="framework/images/st_logo.svg" alt="" >';
		str += '</div>';
	str += '</div>';
	if(APP.configObj.debugMode){
		str += '<div id="debug-screener" class="debug-screener" >';
			str += '<span class="txt"></span>';
			str += '<input type="text" id="debug-screen-input" class="debug-screen-input" placeholder ="type screen id here" />';
			str += '<a class="btn debug-go-btn" href="javascript:void(0);"><span class="btn-txt">Go</span></a>';
		str += '</div>';
	}	
	str += '</div>';
	str += '<div id="net-con"></div>';
	/* 1 */str += '</div>'
	return str;
}
function myCallBack(result){
	 if(result == false){ 
		 APP.commonFunObj.showNetworkFailPop();
	}
}
function onBeforeUnloaded(e){
	if(!APP.winWillClose){
		 e.preventDefault();
		  // Chrome requires returnValue to be set
		  var str="Are you sure you wish to exit?";
		  if(APP.globalXmlsObj){
			  if(APP.globalXmlsObj.globalXML.exitPopText[0].headerBar){
				str = APP.globalXmlsObj.globalXML.exitPopText[0].headerBar[0].title[0].Text;
			  }else{
				str = APP.globalXmlsObj.globalXML.exitPopText[0].ostPanel[0].text[0].Text;
			  }
			  
		  }
		  e.returnValue = str;
		
	}
}
function winUnloaded(e){
	if(APP.configObj!=null){
		var compType=APP.configObj.tracking.complianceType;
		if((compType!= null && compType.toString() != "0") && APP.dataComObj != null){
			APP.dataComObj.closeCourse();
		}	
	}
}	